diff -ru pdns-recursor-4.8.0/rec-main.cc pdns-recursor-4.8.1/rec-main.cc
--- pdns-recursor-4.8.0/rec-main.cc	2022-12-09 10:46:42.000000000 +0000
+++ pdns-recursor-4.8.1/rec-main.cc	2023-01-04 12:13:35.507122391 +0000
@@ -2583,7 +2583,7 @@
   try {
 #if HAVE_FIBER_SANITIZER
     // Asan needs more stack
-    ::arg().set("stack-size", "stack size per mthread") = "400000";
+    ::arg().set("stack-size", "stack size per mthread") = "600000";
 #else
     ::arg().set("stack-size", "stack size per mthread") = "200000";
 #endif
diff -ru pdns-recursor-4.8.0/syncres.cc pdns-recursor-4.8.1/syncres.cc
--- pdns-recursor-4.8.0/syncres.cc	2022-12-09 10:46:42.000000000 +0000
+++ pdns-recursor-4.8.1/syncres.cc	2023-01-04 12:13:35.511122425 +0000
@@ -1753,6 +1753,8 @@
         // Case 5: unexpected answer
         QLOG("Step5: other rcode, last effort final resolve");
         setQNameMinimization(false);
+        setQMFallbackMode(true);
+
         // We might have hit a depth level check, but we still want to allow some recursion levels in the fallback
         // no-qname-minimization case. This has the effect that a qname minimization fallback case might reach 150% of
         // maxdepth.
@@ -3589,7 +3591,7 @@
 
   vState state = vState::Indeterminate;
   const bool oldCacheOnly = setCacheOnly(false);
-  const bool oldQM = setQNameMinimization(true);
+  const bool oldQM = setQNameMinimization(!getQMFallbackMode());
   int rcode = doResolve(zone, QType::DS, dsrecords, depth + 1, beenthere, state);
   setCacheOnly(oldCacheOnly);
   setQNameMinimization(oldQM);
diff -ru pdns-recursor-4.8.0/syncres.hh pdns-recursor-4.8.1/syncres.hh
--- pdns-recursor-4.8.0/syncres.hh	2022-12-09 10:46:42.000000000 +0000
+++ pdns-recursor-4.8.1/syncres.hh	2023-01-04 12:13:35.511122425 +0000
@@ -328,6 +328,18 @@
     return old;
   }
 
+  bool setQMFallbackMode(bool state = true)
+  {
+    auto old = d_qNameMinimizationFalbackMode;
+    d_qNameMinimizationFalbackMode = state;
+    return old;
+  }
+
+  bool getQMFallbackMode() const
+  {
+    return d_qNameMinimizationFalbackMode;
+  }
+
   void setDoEDNS0(bool state=true)
   {
     d_doEDNS0=state;
@@ -664,6 +676,7 @@
   bool d_wasOutOfBand{false};
   bool d_wasVariable{false};
   bool d_qNameMinimization{false};
+  bool d_qNameMinimizationFalbackMode{false};
   bool d_queryReceivedOverTCP{false};
   bool d_followCNAME{true};
   bool d_refresh{false};
